[LeetCode 514] Freedom Trail

In the video game Fallout 4, the quest "Road to Freedom" requires players to reach a metal dial called the "Freedom Trail Ring", and use the dial to spell a specific keyword in order to open the door.

Given a string ring, which represents the code engraved on the outer ring and another string key, which represents the keyword needs to be spelled. You need to find the minimum number of steps in order to spell all the characters in the keyword.

Initially, the first character of the ring is aligned at 12:00 direction. You need to spell all the characters in the string key one by one by rotating the ring clockwise or anticlockwise to make each character of the string key aligned at 12:00 direction and then by pressing the center button.

At the stage of rotating the ring to spell the key character key[i]:

  1. You can rotate the ring clockwise or anticlockwise one place, which counts as 1 step. The final purpose of the rotation is to align one of the string ring's characters at the 12:00 direction, where this character must equal to the character key[i].
  2. If the character key[i] has been aligned at the 12:00 direction, you need to press the center button to spell, which also counts as 1 step. After the pressing, you could begin to spell the next character in the key (next stage), otherwise, you've finished all the spelling.

Example:

 

Input: ring = "godding", key = "gd"
Output: 4
Explanation:
For the first key character 'g', since it is already in place, we just need 1 step to spell this character. 
For the second key character 'd', we need to rotate the ring "godding" anticlockwise by two steps to make it become "ddinggo".Also, we need 1 more step for spelling.So the final output is 4.

Note:

  1. Length of both ring and key will be in range 1 to 100.
  2. There are only lowercase letters in both strings and might be some duplcate characters in both strings.
  3. It's guaranteed that string key could always be spelled by rotating the string ring.

分析

这道题也是一道难题,难点在于如何使用二维数组表示动态规划的状态。

之前打算使用贪心算法每次都找到最短的步数,但是贪心算法的局部最优解不一定是全局最优解,所以这个办法是行不通的。

使用动态规划的二维数组表示可以使用dp[i][j]表示ring已经匹配了key[i]时,此时拧到ring的第j位时需要的步骤。

Code

class Solution {
public:
    int findRotateSteps(string ring, string key) {
        int rlen = ring.size();
        int klen = key.size();
        
        vector<vector<int>> dp(klen+1, vector<int>(rlen, 0));
        
        for (int i = klen -1; i >= 0; i --)
        {
            for (int j = 0; j < rlen; j ++)
            {
                dp[i][j] = INT_MAX;
                for (int k = 0; k < rlen; k ++)
                {
                    if (ring[k] == key[i])
                    {
                        int diff = abs(k-j);
                        int step = min(diff, rlen-diff);
                        dp[i][j] = min(dp[i][j], dp[i+1][k] + step);
                    }
                }
            }
        }
        return dp[0][0] + klen;
    }
};

运行效率

Runtime: 216 ms, faster than 18.51% of C++ online submissions for Freedom Trail.

Memory Usage: 15.5 MB, less than 53.77% of C++ online submissions forFreedom Trail.

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值